package com.gic.plug.web.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.plug.web.utils.storeresourceauth.StoreResourceUtils;
import com.gic.plug.web.vo.StoreTagVO;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreTagDTO;
import com.gic.store.service.StoreTagApiService;
import com.gic.store.service.StoreWidgetApiService;

/**
 * 门店选择器-门店标签
 * @ClassName:
 * @Description:  
 * @author guojuxing 
 * @date 2021/1/15 10:24 AM 
 */
@RestController
@RequestMapping("/store-tag")
public class StoreTagController {
    @Autowired
    private StoreTagApiService storeTagApiService;
    @Autowired
    private StoreWidgetApiService storeWidgetApiService;

    @RequestMapping("/list-store-tag")
    public RestResponse list() {
        ServiceResponse<List<StoreTagDTO>> response = storeTagApiService.listByEnterprise(UserDetailUtils.getUserDetail().getEnterpriseId());
        if (response.isSuccess()) {
            List<StoreTagDTO> result = StoreResourceUtils.auth(
                    response.getResult(),
                    StoreESFieldsEnum.STORETAG.getField(),
                    storeWidgetApiService);
            return RestResponse.success(EntityUtil.changeEntityListNew(StoreTagVO.class, result));
        }
        return RestResponse.failure(response.getCode(), response.getMessage());
    }
}
