package com.gic.plug.web.strategy.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.plug.web.vo.ScreenBack;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.CityDTO;
import com.gic.store.dto.ProvinceDTO;
import com.gic.store.service.ProvincesApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
/**
 * 门店
 * @ClassName: StoreAreaBackImpl 
 * @Description:  
 * @author boom 
 * @date 2020/9/14 10:40 AM 
 */
@Component
public class StoreAreaBackImpl implements ScreenBackStrategy {
    @Autowired
    private ProvincesApiService provincesApiService;
    @Override
    public ScreenBack screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            ServiceResponse<List<CityDTO>> cityResponse = this.provincesApiService.selectAllCity();
            ScreenBack screenBack = new ScreenBack();
            screenBack.setTitle(StoreESFieldsEnum.AREAIDS.getDesc());
            screenBack.setCompute(ComputeBackUtil.getComputeBack(compute));
            if(cityResponse.isSuccess()){
                List<CityDTO> cityDTOList = cityResponse.getResult();
                if(CollectionUtils.isNotEmpty(cityDTOList)){
                    String[] valueArr = value.split(" ");
                    List<String> view = new ArrayList<>();
                    List<String> hideView = new ArrayList<>();
                    int index = 0;
                    for(String s : valueArr){
                        for(CityDTO cityDTO : cityDTOList){
                            if(s.equals(cityDTO.getCityId())){
                                String provinceName = "";
                                ServiceResponse<ProvinceDTO> provinceById = this.provincesApiService.getProvinceById(cityDTO.getProvinceId());
                                if(provinceById.isSuccess()){
                                    provinceName = provinceById.getResult().getProvinceName();
                                }
                                if(index < 5){
                                    view.add(cityDTO.getCityName() + "-" + provinceName);
                                }else {
                                    hideView.add(cityDTO.getCityName() + "-" + provinceName);
                                }
                                index++;
                            }
                        }
                    }
                    screenBack.setView(view);
                    screenBack.setHideView(hideView);
                }
            }
            return screenBack;
        }
        return null;
    }
}
