package com.gic.plug.web.strategy.impl;

import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.plug.web.vo.ScreenBack;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreDTO;
import com.gic.store.dto.StoreSearchDTO;
import com.gic.store.service.StoreApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
/**
 * 门店回显
 * @ClassName: StoreBackImpl 
 * @Description:  
 * @author boom 
 * @date 2020/9/14 10:41 AM 
 */
@Component
public class StoreBackImpl implements ScreenBackStrategy {
    @Autowired
    private StoreApiService storeApiService;
    @Override
    public ScreenBack screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            ScreenBack screenBack = new ScreenBack();
            screenBack.setTitle(StoreESFieldsEnum.STORENAME.getDesc());
            screenBack.setCompute(ComputeBackUtil.getComputeBack(compute));
            StoreSearchDTO storeSearchDTO = new StoreSearchDTO();
            storeSearchDTO.setEnterpriseId(enterpriseId);
            storeSearchDTO.setStoreIds(value);
            ServiceResponse<Page<StoreDTO>> response = this.storeApiService.listStore(storeSearchDTO, 1, 50, StoreESFieldsEnum.STORENAME.getField());
            if(response.isSuccess()){
                List<StoreDTO> list = ((Page)response.getResult()).getResult();
                if(CollectionUtils.isNotEmpty(list)){
                    List<String> view = new ArrayList<>();
                    List<String> hideView = new ArrayList<>();
                    int index = 0;
                    for (StoreDTO storeDTO : list) {
                        if(index < 5){
                            view.add(storeDTO.getStoreName());
                        }else {
                            hideView.add(storeDTO.getStoreName());
                        }
                        index++;
                    }
                    screenBack.setView(view);
                    screenBack.setHideView(hideView);
                }
            }
            return screenBack;
        }
        return null;
    }
}
