package com.gic.plug.web.strategy.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.plug.web.vo.ScreenBack;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreBrandDTO;
import com.gic.store.service.StoreBrandApiService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
/**
 * 门店品牌
 * @ClassName: StoreBrandBackImpl 
 * @Description:  
 * @author boom 
 * @date 2020/9/14 10:40 AM 
 */
@Component
public class StoreBrandBackImpl implements ScreenBackStrategy {
    @Autowired
    private StoreBrandApiService storeBrandApiService;
    @Override
    public ScreenBack screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            ScreenBack screenBack = new ScreenBack();
            screenBack.setTitle(StoreESFieldsEnum.STOREBRANDIDLIST.getDesc());
            screenBack.setCompute(ComputeBackUtil.getComputeBack(compute));
            List<Integer> storeBrandIdList = new ArrayList<>();
            String[] valueArr = value.split(" ");
            for(String s : valueArr){
                storeBrandIdList.add(Integer.valueOf(s));
            }
            ServiceResponse<List<StoreBrandDTO>> listServiceResponse = this.storeBrandApiService.listStoreBrandByIds(storeBrandIdList);
            if(listServiceResponse.isSuccess()){
                List<StoreBrandDTO> list = listServiceResponse.getResult();
                List<String> view = new ArrayList<>();
                List<String> hideView = new ArrayList<>();
                int index = 0;
                for(StoreBrandDTO storeBrandDTO : list){
                    if(index <5){
                        view.add(storeBrandDTO.getStoreBrandName());
                    }else {
                        hideView.add(storeBrandDTO.getStoreBrandName());
                    }
                    index++;
                }
                screenBack.setView(view);
                screenBack.setHideView(hideView);
            }
            return screenBack;
        }
        return null;
    }
}
