package com.gic.plug.web.strategy.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.plug.web.vo.ScreenBack;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreGroupDTO;
import com.gic.store.service.StoreGroupApiService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
/**
 * 门店分组回显
 * @ClassName: StoreGroupBackImpl 
 * @Description:  
 * @author boom 
 * @date 2020/9/14 10:40 AM 
 */
@Component
public class StoreGroupBackImpl implements ScreenBackStrategy {
    @Autowired
    private StoreGroupApiService storeGroupApiService;
    @Override
    public ScreenBack screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            ScreenBack screenBack = new ScreenBack();
            screenBack.setTitle(StoreESFieldsEnum.STOREGROUPIDLIST.getDesc());
            screenBack.setCompute(ComputeBackUtil.getComputeBack(compute));
            String[] valueArr = value.split(" ");
            List<Integer> storeGroupIdList = new ArrayList<>();
            for(String s : valueArr){
                storeGroupIdList.add(Integer.valueOf(s));
            }
            ServiceResponse<List<StoreGroupDTO>> listServiceResponse = this.storeGroupApiService.listStoreGroupByIds(storeGroupIdList, enterpriseId);
            if(listServiceResponse.isSuccess()){
                if(listServiceResponse.getResult() != null){
                    List<String> view = new ArrayList<>();
                    List<String> hideView = new ArrayList<>();
                    int index=0;
                    for(StoreGroupDTO storeGroupDTO : listServiceResponse.getResult()){
                        if(index < 5){
                            view.add(storeGroupDTO.getStoreGroupName());
                        } else {
                            hideView.add(storeGroupDTO.getStoreGroupName());
                        }
                        index++;
                    }
                    screenBack.setView(view);
                    screenBack.setHideView(hideView);
                }
            }
            return screenBack;
        }
        return null;
    }
}
