package com.gic.plug.web.strategy.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.plug.web.vo.ScreenBack;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreRegionDTO;
import com.gic.store.service.StoreRegionApiService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
/**
 * 门店域回显
 * @ClassName: StoreRegionBackImpl 
 * @Description:  
 * @author boom 
 * @date 2020/9/14 10:40 AM 
 */
@Component
public class StoreRegionBackImpl implements ScreenBackStrategy {
    @Autowired
    private StoreRegionApiService storeRegionApiService;
    @Override
    public ScreenBack screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            ScreenBack screenBack = new ScreenBack();
            screenBack.setTitle(StoreESFieldsEnum.REGIONID.getDesc());
            screenBack.setCompute(ComputeBackUtil.getComputeBack(compute));
            String[] valueArr = value.split(" ");
            List<Integer> storeRegionIdList = new ArrayList<>();
            for(String s : valueArr){
                storeRegionIdList.add(Integer.valueOf(s));
            }
            ServiceResponse<List<StoreRegionDTO>> listServiceResponse = this.storeRegionApiService.listStoreRegionByIds(enterpriseId, storeRegionIdList);
            if(listServiceResponse.isSuccess()){
                if(listServiceResponse.getResult() != null){
                    List<String> view = new ArrayList<>();
                    List<String> hideView = new ArrayList<>();
                    int index = 0;
                    for(StoreRegionDTO storeRegionDTO : listServiceResponse.getResult()){
                        if(index < 5){
                            view.add(storeRegionDTO.getRegionName());
                        } else {
                            hideView.add(storeRegionDTO.getRegionName());
                        }
                        index++;
                    }
                    screenBack.setView(view);
                    screenBack.setHideView(hideView);
                }
            }
            return screenBack;
        }
        return null;
    }
}
