package com.gic.plug.web.strategy.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.plug.web.vo.ScreenBack;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreGroupDTO;
import com.gic.store.dto.StoreTagDTO;
import com.gic.store.service.StoreTagApiService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
/**
 * 门店表情
 * @ClassName: StoreTagBackImpl 
 * @Description:  
 * @author boom 
 * @date 2020/9/14 10:39 AM 
 */
@Component
public class StoreTagBackImpl implements ScreenBackStrategy {
    @Autowired
    private StoreTagApiService storeTagApiService;
    @Override
    public ScreenBack screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            ScreenBack screenBack = new ScreenBack();
            screenBack.setTitle(StoreESFieldsEnum.STORETAG.getDesc());
            screenBack.setCompute(ComputeBackUtil.getComputeBack(compute));
            String[] valueArr = value.split(" ");
            int index = 0;
            List<String> view = new ArrayList<>();
            List<String> hideView = new ArrayList<>();
            for(String s : valueArr){
                ServiceResponse<StoreTagDTO> response = this.storeTagApiService.getByStoreTagId(Integer.valueOf(s));
                if(response.isSuccess() && response.getResult()!= null){
                    if(index < 0){
                        view.add(response.getResult().getStoreTagName());
                    } else {
                        hideView.add(response.getResult().getStoreTagName());
                    }
                    index++;
                }
            }
            screenBack.setView(view);
            screenBack.setHideView(hideView);
            return screenBack;
        }
        return null;
    }
}
