package com.gic.plug.web.strategy.init;

import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.strategy.impl.*;
import com.gic.store.constant.StoreESFieldsEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.Map;
/**
 * 回显
 * @ClassName: StrategyInit 
 * @Description:  
 * @author boom 
 * @date 2020/9/14 10:41 AM 
 */
@Component
public class StrategyInit {
    @Autowired
    private StoreAreaBackImpl storeAreaBack;
    @Autowired
    private StoreBackImpl storeBack;
    @Autowired
    private StoreBrandBackImpl storeBrandBack;
    @Autowired
    private StoreCustomBackImpl storeCustomBack;
    @Autowired
    private StoreGroupBackImpl storeGroupBack;
    @Autowired
    private StoreRegionBackImpl storeRegionBack;
    @Autowired
    private StoreSelectBackImpl storeSelectBack;
    @Autowired
    private StoreTagBackImpl storeTagBack;
    private Map<String, ScreenBackStrategy> strategyMap = new HashMap<>();

    @PostConstruct
    public void init(){
        strategyMap.put(StoreESFieldsEnum.AREAIDS.getField(), this.getStoreAreaBack());
        strategyMap.put(StoreESFieldsEnum.STOREID.getField(), this.getStoreBack());
        strategyMap.put(StoreESFieldsEnum.STOREBRANDIDLIST.getField(), this.getStoreBrandBack());
        strategyMap.put(StoreESFieldsEnum.STOREGROUPIDLIST.getField(), this.getStoreGroupBack());
        strategyMap.put(StoreESFieldsEnum.REGIONID.getField(), this.getStoreRegionBack());
        strategyMap.put(StoreESFieldsEnum.STATUS.getField(), this.getStoreSelectBack());
        strategyMap.put(StoreESFieldsEnum.COMPLETESTATUS.getField(), this.getStoreSelectBack());
        strategyMap.put(StoreESFieldsEnum.CREATETYPE.getField(), this.getStoreSelectBack());
        strategyMap.put(StoreESFieldsEnum.STORETYPE.getField(), this.getStoreSelectBack());
        strategyMap.put(StoreESFieldsEnum.STORETAG.getField(), this.getStoreTagBack());
        strategyMap.put(StoreESFieldsEnum.C1.getField(), this.getStoreCustomBack());
        strategyMap.put(StoreESFieldsEnum.C2.getField(), this.getStoreCustomBack());
        strategyMap.put(StoreESFieldsEnum.C3.getField(), this.getStoreCustomBack());
        strategyMap.put(StoreESFieldsEnum.C4.getField(), this.getStoreCustomBack());
        strategyMap.put(StoreESFieldsEnum.C5.getField(), this.getStoreCustomBack());
        strategyMap.put(StoreESFieldsEnum.C6.getField(), this.getStoreCustomBack());
        strategyMap.put(StoreESFieldsEnum.C7.getField(), this.getStoreCustomBack());
        strategyMap.put(StoreESFieldsEnum.C8.getField(), this.getStoreCustomBack());
        strategyMap.put(StoreESFieldsEnum.C9.getField(), this.getStoreCustomBack());
        strategyMap.put(StoreESFieldsEnum.C10.getField(), this.getStoreCustomBack());
    }

    public StoreAreaBackImpl getStoreAreaBack() {
        return storeAreaBack;
    }

    public StoreBackImpl getStoreBack() {
        return storeBack;
    }

    public StoreBrandBackImpl getStoreBrandBack() {
        return storeBrandBack;
    }

    public StoreCustomBackImpl getStoreCustomBack() {
        return storeCustomBack;
    }

    public StoreGroupBackImpl getStoreGroupBack() {
        return storeGroupBack;
    }

    public StoreRegionBackImpl getStoreRegionBack() {
        return storeRegionBack;
    }

    public StoreSelectBackImpl getStoreSelectBack() {
        return storeSelectBack;
    }

    public StoreTagBackImpl getStoreTagBack() {
        return storeTagBack;
    }

    public Map<String, ScreenBackStrategy> getStrategyMap() {
        return strategyMap;
    }
}
