package com.gic.plug.web.utils.storeresourceauth;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import com.gic.store.dto.StoreBrandDTO;
import org.apache.commons.collections.CollectionUtils;

/**
 * 店招品牌过滤
 * @ClassName:
 * @Description:  
 * @author guojuxing 
 * @date 2021/1/14 6:41 PM 
 */
public class StoreBrandAuth implements IStoreResourceAuth<StoreBrandDTO>{
    @Override
    public List<StoreBrandDTO> auth(List<StoreBrandDTO> data, Set<String> authData) {
        if (CollectionUtils.isEmpty(data)) {
            return data;
        }
        if (authData.isEmpty()) {
            return data;
        }
        //权限过滤
        List<StoreBrandDTO> authList = new ArrayList<>();
        for (StoreBrandDTO obj : data) {
            if (authData.contains(obj.getStoreBrandId() + "")) {
                authList.add(obj);
            }
        }
        return authList;
    }
}
