package com.gic.plug.web.utils.storeresourceauth;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.redis.data.util.RedisUtil;
import com.gic.store.utils.StoreRedisKeyUtils;
import org.apache.commons.collections.CollectionUtils;

import com.gic.store.dto.StoreFieldDTO;
/**
 * 自定义属性权限过滤
 * @ClassName:
 * @Description:  
 * @author guojuxing 
 * @date 2021/1/14 7:02 PM 
 */
public class StoreFieldAuth implements IStoreResourceAuth<StoreFieldDTO>{
    @Override
    public List<StoreFieldDTO> auth(List<StoreFieldDTO> data, Set<String> authData) {
        if (CollectionUtils.isEmpty(data)) {
            return data;
        }
        if (authData.isEmpty()) {
            return data;
        }
        //权限过滤
        List<StoreFieldDTO> authList = new ArrayList<>();
        //转化自定义字段key为ID
        //因为自定义字段，ES最多10个，c1-c10，选择器存的是key值，需要先转化为ID
        String keyC = StoreRedisKeyUtils.getStoreFieldKeyC(UserDetailUtils.getUserDetail().getEnterpriseId(), "");
        Set<String> authStoreFieldSet = new HashSet<>(authData.size());
        for (String key : authData) {
            Object storeFieldId = RedisUtil.getCache(keyC + key);
            if (storeFieldId != null) {
                authStoreFieldSet.add((String) storeFieldId);
            }
        }
        for (StoreFieldDTO obj : data) {
            if (authStoreFieldSet.contains(obj.getStoreFieldId() + "")) {
                authList.add(obj);
            }
        }
        return authList;
    }
}
