package com.gic.plug.web.utils.storeresourceauth;

import com.gic.plug.web.utils.StoreResourceAuthUtils;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.service.StoreWidgetApiService;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 资源组-门店资源过滤工具类
 * @ClassName:
 * @Description:  
 * @author guojuxing 
 * @date 2021/1/14 4:57 PM 
 */
public class StoreResourceUtils {
    private static Map<String, IStoreResourceAuth> map = new HashMap<>(16);
    public final static String STORE_FIELD_KEY = "storeFieldKey";

    static {
        //门店分组不用过滤
        map.put(StoreESFieldsEnum.STOREGROUPIDLIST.getField(), new StoreGroupAuth());
        map.put(StoreESFieldsEnum.STOREBRANDIDLIST.getField(), new StoreBrandAuth());
        map.put(STORE_FIELD_KEY, new StoreFieldAuth());
        map.put(StoreESFieldsEnum.STOREID.getField(), new StorePartAuth());
        map.put(StoreESFieldsEnum.STORETAG.getField(), new StoreTagAuth());
    }

    /**
     * 业务方过滤权限
     * @param serviceData 业务方数据
     * @param field StoreESFieldsEnum 门店分组/门店域.....
     * @param storeWidgetApiService 门店选择器服务
     * @param <T>
     * @return
     */
    public static <T> T auth(List serviceData, String field, StoreWidgetApiService storeWidgetApiService) {
        Set<String> authSet = StoreResourceAuthUtils.getAuthData(field, storeWidgetApiService);
        return (T) map.get(field).auth(serviceData, authSet);
    }
}
